#include "sbdnssecconsts.h"

void Register_SBDNSSECConsts_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_RSAMD5, SB_DNS_ALGORITHM_RSAMD5, SB_DNS_ALGORITHM_RSAMD5);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_DH, SB_DNS_ALGORITHM_DH, SB_DNS_ALGORITHM_DH);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_DSASHA1, SB_DNS_ALGORITHM_DSASHA1, SB_DNS_ALGORITHM_DSASHA1);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_ECC, SB_DNS_ALGORITHM_ECC, SB_DNS_ALGORITHM_ECC);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_RSASHA1, SB_DNS_ALGORITHM_RSASHA1, SB_DNS_ALGORITHM_RSASHA1);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_DSA_NSEC3_SHA1, SB_DNS_ALGORITHM_DSA_NSEC3_SHA1, SB_DNS_ALGORITHM_DSA_NSEC3_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_RSASHA1_NSEC3_SHA1, SB_DNS_ALGORITHM_RSASHA1_NSEC3_SHA1, SB_DNS_ALGORITHM_RSASHA1_NSEC3_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_RSASHA256, SB_DNS_ALGORITHM_RSASHA256, SB_DNS_ALGORITHM_RSASHA256);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_RSASHA512, SB_DNS_ALGORITHM_RSASHA512, SB_DNS_ALGORITHM_RSASHA512);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_INDIRECT, SB_DNS_ALGORITHM_INDIRECT, SB_DNS_ALGORITHM_INDIRECT);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_PRIVATEDNS, SB_DNS_ALGORITHM_PRIVATEDNS, SB_DNS_ALGORITHM_PRIVATEDNS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ALGORITHM_PRIVATEOID, SB_DNS_ALGORITHM_PRIVATEOID, SB_DNS_ALGORITHM_PRIVATEOID);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_DIGEST_SHA1, SB_DNS_DIGEST_SHA1, SB_DNS_DIGEST_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_DIGEST_SHA256, SB_DNS_DIGEST_SHA256, SB_DNS_DIGEST_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_CODE_BASE, SB_DNS_CODE_BASE, SB_DNS_CODE_BASE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_SUCCESS, SB_DNS_RESULT_SUCCESS, SB_DNS_RESULT_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_FIRST, SB_DNS_RESULT_FIRST, SB_DNS_RESULT_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_LAST, SB_DNS_RESULT_LAST, SB_DNS_RESULT_LAST);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_NAME_NOT_FOUND, SB_DNS_RESULT_NAME_NOT_FOUND, SB_DNS_RESULT_NAME_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_INFO_NOT_FOUND, SB_DNS_RESULT_INFO_NOT_FOUND, SB_DNS_RESULT_INFO_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_SERVER_FAILURE, SB_DNS_RESULT_SERVER_FAILURE, SB_DNS_RESULT_SERVER_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_RESULT_TIMEOUT, SB_DNS_RESULT_TIMEOUT, SB_DNS_RESULT_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_SUCCESS, SB_DNS_VERIFY_SUCCESS, SB_DNS_VERIFY_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_FIRST, SB_DNS_VERIFY_FIRST, SB_DNS_VERIFY_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_NO_SIGNATURE, SB_DNS_VERIFY_NO_SIGNATURE, SB_DNS_VERIFY_NO_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_NO_SIGNED_RECORDS, SB_DNS_VERIFY_NO_SIGNED_RECORDS, SB_DNS_VERIFY_NO_SIGNED_RECORDS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_INVALID_SIGNER, SB_DNS_VERIFY_INVALID_SIGNER, SB_DNS_VERIFY_INVALID_SIGNER);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_SIGNATURE_EXPIRED, SB_DNS_VERIFY_SIGNATURE_EXPIRED, SB_DNS_VERIFY_SIGNATURE_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_SIGNATURE_NOT_YET_VALID, SB_DNS_VERIFY_SIGNATURE_NOT_YET_VALID, SB_DNS_VERIFY_SIGNATURE_NOT_YET_VALID);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_UNKNOWN_ALGORITHM, SB_DNS_VERIFY_UNKNOWN_ALGORITHM, SB_DNS_VERIFY_UNKNOWN_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_NO_KEY, SB_DNS_VERIFY_NO_KEY, SB_DNS_VERIFY_NO_KEY);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_INVALID_KEY, SB_DNS_VERIFY_INVALID_KEY, SB_DNS_VERIFY_INVALID_KEY);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_INVALID_SIGNATURE, SB_DNS_VERIFY_INVALID_SIGNATURE, SB_DNS_VERIFY_INVALID_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_FAILED, SB_DNS_VERIFY_FAILED, SB_DNS_VERIFY_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_NOT_CHECKED, SB_DNS_VERIFY_NOT_CHECKED, SB_DNS_VERIFY_NOT_CHECKED);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_TIMEOUT, SB_DNS_VERIFY_TIMEOUT, SB_DNS_VERIFY_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_INSECURE, SB_DNS_VERIFY_INSECURE, SB_DNS_VERIFY_INSECURE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_INDETERMINATE, SB_DNS_VERIFY_INDETERMINATE, SB_DNS_VERIFY_INDETERMINATE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_BOGUS, SB_DNS_VERIFY_BOGUS, SB_DNS_VERIFY_BOGUS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_VERIFY_LAST, SB_DNS_VERIFY_LAST, SB_DNS_VERIFY_LAST);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ERROR_BASE, SB_DNS_ERROR_BASE, SB_DNS_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_OUT_OF_BUFFER, SB_DNS_OUT_OF_BUFFER, SB_DNS_OUT_OF_BUFFER);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_MESSAGE_SIZE, SB_DNS_INVALID_MESSAGE_SIZE, SB_DNS_INVALID_MESSAGE_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_RESOURCE_TYPE, SB_DNS_INVALID_RESOURCE_TYPE, SB_DNS_INVALID_RESOURCE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_OPERATION_CODE, SB_DNS_INVALID_OPERATION_CODE, SB_DNS_INVALID_OPERATION_CODE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_RESPONSE_CODE, SB_DNS_INVALID_RESPONSE_CODE, SB_DNS_INVALID_RESPONSE_CODE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_UNKNOWN_QUESTION_CLASS, SB_DNS_UNKNOWN_QUESTION_CLASS, SB_DNS_UNKNOWN_QUESTION_CLASS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_IPv4_DATA_SIZE, SB_DNS_INVALID_IPv4_DATA_SIZE, SB_DNS_INVALID_IPv4_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_IPv6_DATA_SIZE, SB_DNS_INVALID_IPv6_DATA_SIZE, SB_DNS_INVALID_IPv6_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_INDEX, SB_DNS_INVALID_INDEX, SB_DNS_INVALID_INDEX);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_WKS_DATA_SIZE, SB_DNS_INVALID_WKS_DATA_SIZE, SB_DNS_INVALID_WKS_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_PUBLIC_KEY_DATA_SIZE, SB_DNS_INVALID_PUBLIC_KEY_DATA_SIZE, SB_DNS_INVALID_PUBLIC_KEY_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_SIGNATURE_DATA_SIZE, SB_DNS_INVALID_SIGNATURE_DATA_SIZE, SB_DNS_INVALID_SIGNATURE_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_DELEGATION_SIGNER_DATA_SIZE, SB_DNS_INVALID_DELEGATION_SIGNER_DATA_SIZE, SB_DNS_INVALID_DELEGATION_SIGNER_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_SERVICE_LOCATION_FORMAT, SB_DNS_INVALID_SERVICE_LOCATION_FORMAT, SB_DNS_INVALID_SERVICE_LOCATION_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_SIGNATURE_NOT_FOUND, SB_DNS_SIGNATURE_NOT_FOUND, SB_DNS_SIGNATURE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_NO_RESOURCE_DATA, SB_DNS_NO_RESOURCE_DATA, SB_DNS_NO_RESOURCE_DATA);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_IPv4_ADDRESS, SB_DNS_INVALID_IPv4_ADDRESS, SB_DNS_INVALID_IPv4_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_INVALID_IPv6_ADDRESS, SB_DNS_INVALID_IPv6_ADDRESS, SB_DNS_INVALID_IPv6_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ERROR_UNASSIGNED_HANDLER, SB_DNS_ERROR_UNASSIGNED_HANDLER, SB_DNS_ERROR_UNASSIGNED_HANDLER);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ERROR_TIMEOUT, SB_DNS_ERROR_TIMEOUT, SB_DNS_ERROR_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBDNSSECConsts, SB_DNS_ERROR_SECURITY_FAILURE, SB_DNS_ERROR_SECURITY_FAILURE, SB_DNS_ERROR_SECURITY_FAILURE);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorOutOfBuffer, SB_SDNSErrorOutOfBuffer, SB_SDNSErrorOutOfBuffer);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidMessageSize, SB_SDNSErrorInvalidMessageSize, SB_SDNSErrorInvalidMessageSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorUnknownQuestionClass, SB_SDNSErrorUnknownQuestionClass, SB_SDNSErrorUnknownQuestionClass);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidIPv4DataSize, SB_SDNSErrorInvalidIPv4DataSize, SB_SDNSErrorInvalidIPv4DataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidIPv6DataSize, SB_SDNSErrorInvalidIPv6DataSize, SB_SDNSErrorInvalidIPv6DataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidIndex, SB_SDNSErrorInvalidIndex, SB_SDNSErrorInvalidIndex);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidWKSDataSize, SB_SDNSErrorInvalidWKSDataSize, SB_SDNSErrorInvalidWKSDataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidPublicKeyDataSize, SB_SDNSErrorInvalidPublicKeyDataSize, SB_SDNSErrorInvalidPublicKeyDataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidSignatureDataSize, SB_SDNSErrorInvalidSignatureDataSize, SB_SDNSErrorInvalidSignatureDataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidDelegationSignerDataSize, SB_SDNSErrorInvalidDelegationSignerDataSize, SB_SDNSErrorInvalidDelegationSignerDataSize);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidServiceLocationFormat, SB_SDNSErrorInvalidServiceLocationFormat, SB_SDNSErrorInvalidServiceLocationFormat);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidIPv4Address, SB_SDNSErrorInvalidIPv4Address, SB_SDNSErrorInvalidIPv4Address);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidIPv6Address, SB_SDNSErrorInvalidIPv6Address, SB_SDNSErrorInvalidIPv6Address);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidVerificationCode, SB_SDNSErrorInvalidVerificationCode, SB_SDNSErrorInvalidVerificationCode);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorSecurityFailure, SB_SDNSErrorSecurityFailure, SB_SDNSErrorSecurityFailure);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidSecurityStatus, SB_SDNSErrorInvalidSecurityStatus, SB_SDNSErrorInvalidSecurityStatus);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidResourceType, SB_SDNSErrorInvalidResourceType, SB_SDNSErrorInvalidResourceType);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidOperationCode, SB_SDNSErrorInvalidOperationCode, SB_SDNSErrorInvalidOperationCode);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorInvalidResponseCode, SB_SDNSErrorInvalidResponseCode, SB_SDNSErrorInvalidResponseCode);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorSocketError, SB_SDNSErrorSocketError, SB_SDNSErrorSocketError);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorSocketTimeout, SB_SDNSErrorSocketTimeout, SB_SDNSErrorSocketTimeout);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorSignatureNotFound, SB_SDNSErrorSignatureNotFound, SB_SDNSErrorSignatureNotFound);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorNoResourceData, SB_SDNSErrorNoResourceData, SB_SDNSErrorNoResourceData);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorNoServers, SB_SDNSErrorNoServers, SB_SDNSErrorNoServers);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorVerifyFailure, SB_SDNSErrorVerifyFailure, SB_SDNSErrorVerifyFailure);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorUnassignedHandler, SB_SDNSErrorUnassignedHandler, SB_SDNSErrorUnassignedHandler);
	SB_REGISTER_STRING_CONSTANT(SBDNSSECConsts, SDNSErrorTimeout, SB_SDNSErrorTimeout, SB_SDNSErrorTimeout);
}

