#include "sbsshforwardinghandlers.h"

zend_class_entry *TElTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTCPForwardingSSHSubsystemHandler", TElTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElCustomSocketForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElCustomSocketForwardingSSHSubsystemHandler(TSRMLS_C);
	TElTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSocketForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElClientTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElClientTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElClientTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElClientTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElClientTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElClientTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElClientTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElClientTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElClientTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElClientTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElClientTCPForwardingSSHSubsystemHandler", TElClientTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	TElClientTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElTCPForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElServerTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElServerTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTCPForwardingSSHSubsystemHandler, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTCPForwardingSSHSubsystemHandler_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTCPForwardingSSHSubsystemHandler, set_Socket)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSocket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElServerTCPForwardingSSHSubsystemHandler_set_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTCPForwardingSSHSubsystemHandler_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTCPForwardingSSHSubsystemHandler_set_Socket, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSocket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElServerTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElServerTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElServerTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElServerTCPForwardingSSHSubsystemHandler, get_Socket, arginfo_TElServerTCPForwardingSSHSubsystemHandler_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTCPForwardingSSHSubsystemHandler, set_Socket, arginfo_TElServerTCPForwardingSSHSubsystemHandler_set_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElServerTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElServerTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElServerTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElServerTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElServerTCPForwardingSSHSubsystemHandler", TElServerTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	TElServerTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElTCPForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltinTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltinTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElBuiltinTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltinTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltinTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElBuiltinTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElBuiltinTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltinTCPForwardingSSHSubsystemHandler", TElBuiltinTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElCustomSocketForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElCustomSocketForwardingSSHSubsystemHandler(TSRMLS_C);
	TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSocketForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltinClientTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinClientTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinClientTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinClientTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinClientTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinClientTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltinClientTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElBuiltinClientTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltinClientTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltinClientTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElBuiltinClientTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElBuiltinClientTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltinClientTCPForwardingSSHSubsystemHandler", TElBuiltinClientTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElBuiltinTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltinServerTCPForwardingSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinServerTCPForwardingSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinServerTCPForwardingSSHSubsystemHandler, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinServerTCPForwardingSSHSubsystemHandler_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinServerTCPForwardingSSHSubsystemHandler, set_Socket)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSocket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltinServerTCPForwardingSSHSubsystemHandler_set_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinServerTCPForwardingSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinServerTCPForwardingSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltinServerTCPForwardingSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltinServerTCPForwardingSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElCustomSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_set_Socket, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSocket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltinServerTCPForwardingSSHSubsystemHandler_methods[] = {
	PHP_ME(TElBuiltinServerTCPForwardingSSHSubsystemHandler, ClassType, arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltinServerTCPForwardingSSHSubsystemHandler, get_Socket, arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltinServerTCPForwardingSSHSubsystemHandler, set_Socket, arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_set_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltinServerTCPForwardingSSHSubsystemHandler, __construct, arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltinServerTCPForwardingSSHSubsystemHandler, CreateDelayed, arginfo_TElBuiltinServerTCPForwardingSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElBuiltinServerTCPForwardingSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltinServerTCPForwardingSSHSubsystemHandler", TElBuiltinServerTCPForwardingSSHSubsystemHandler_methods);
	if (NULL == TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElBuiltinTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHForwardingHandlers_Aliases(TSRMLS_D)
{
	if (NULL == TElTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElTCPForwardingSSHSubsystemHandler", TElTCPForwardingSSHSubsystemHandler_ce_ptr);
	if (NULL == TElClientTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElClientTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElClientTCPForwardingSSHSubsystemHandler", TElClientTCPForwardingSSHSubsystemHandler_ce_ptr);
	if (NULL == TElServerTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElServerTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElServerTCPForwardingSSHSubsystemHandler", TElServerTCPForwardingSSHSubsystemHandler_ce_ptr);
	if (NULL == TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElBuiltinTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElBuiltinTCPForwardingSSHSubsystemHandler", TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr);
	if (NULL == TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElBuiltinClientTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElBuiltinClientTCPForwardingSSHSubsystemHandler", TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr);
	if (NULL == TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr)
		Register_TElBuiltinServerTCPForwardingSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElBuiltinServerTCPForwardingSSHSubsystemHandler", TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr);
}

