#include "sbwebsocketserver.h"

zend_class_entry *TElWebSocketServer_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketServer, __construct)
{
	zval *oControl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketServer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oControl, TElSSLClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketServer_Create_1(SBGetObjectHandle(oControl TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElSSLClass)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketServer___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Control, TElSSLClass, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketServer_methods[] = {
	PHP_ME(TElWebSocketServer, __construct, arginfo_TElWebSocketServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketServer", TElWebSocketServer_methods);
	if (NULL == TElWebSocketBase_ce_ptr)
		Register_TElWebSocketBase(TSRMLS_C);
	TElWebSocketServer_ce_ptr = zend_register_internal_class_ex(&ce, TElWebSocketBase_ce_ptr, NULL TSRMLS_CC);
}

