#include "sbdtlsclient.h"

zend_class_entry *TElDTLSClient_ce_ptr = NULL;

SB_PHP_METHOD(TElDTLSClient, get_DatagramSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_DatagramSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, set_DatagramSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDTLSClient_set_DatagramSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, get_MaxDataSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_MaxDataSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, get_SplitLongData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_SplitLongData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, set_SplitLongData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDTLSClient_set_SplitLongData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, get_UseRetransmissionTimer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_UseRetransmissionTimer(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, set_UseRetransmissionTimer)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDTLSClient_set_UseRetransmissionTimer(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, get_TimerValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_TimerValue(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, set_TimerValue)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDTLSClient_set_TimerValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, get_AutoAdjustTimerValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDTLSClient_get_AutoAdjustTimerValue(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, set_AutoAdjustTimerValue)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDTLSClient_set_AutoAdjustTimerValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDTLSClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDTLSClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_DatagramSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_set_DatagramSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_MaxDataSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_SplitLongData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_set_SplitLongData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_UseRetransmissionTimer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_set_UseRetransmissionTimer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_TimerValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_set_TimerValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_get_AutoAdjustTimerValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient_set_AutoAdjustTimerValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDTLSClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDTLSClient_methods[] = {
	PHP_ME(TElDTLSClient, get_DatagramSize, arginfo_TElDTLSClient_get_DatagramSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, set_DatagramSize, arginfo_TElDTLSClient_set_DatagramSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, get_MaxDataSize, arginfo_TElDTLSClient_get_MaxDataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, get_SplitLongData, arginfo_TElDTLSClient_get_SplitLongData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, set_SplitLongData, arginfo_TElDTLSClient_set_SplitLongData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, get_UseRetransmissionTimer, arginfo_TElDTLSClient_get_UseRetransmissionTimer, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, set_UseRetransmissionTimer, arginfo_TElDTLSClient_set_UseRetransmissionTimer, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, get_TimerValue, arginfo_TElDTLSClient_get_TimerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, set_TimerValue, arginfo_TElDTLSClient_set_TimerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, get_AutoAdjustTimerValue, arginfo_TElDTLSClient_get_AutoAdjustTimerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, set_AutoAdjustTimerValue, arginfo_TElDTLSClient_set_AutoAdjustTimerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDTLSClient, __construct, arginfo_TElDTLSClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDTLSClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDTLSClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDTLSClient", TElDTLSClient_methods);
	if (NULL == TElSSLClient_ce_ptr)
		Register_TElSSLClient(TSRMLS_C);
	TElDTLSClient_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBDTLSClient_Aliases(TSRMLS_D)
{
	if (NULL == TElDTLSClient_ce_ptr)
		Register_TElDTLSClient(TSRMLS_C);
	zend_register_class_alias("ElDTLSClient", TElDTLSClient_ce_ptr);
}

