#include "sbmd.h"

SB_PHP_METHOD(TMD5Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMD5Context));
		intern->len = sizeof(TMD5Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMD5Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMD5Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TMD5Context, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMD5Context, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMD5Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TMD5Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TMD5Context, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TMD5Context, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TMD5Context, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TMD5Context, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TMD5Context, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TMD5Context, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TMD5Context, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(TMD5Context, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

zend_class_entry *TMD5Context_ce_ptr = NULL;

static zend_function_entry TMD5Context_methods[] = {
	PHP_ME(TMD5Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMD5Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD5Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMD5Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMD5Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMD5Context", TMD5Context_methods);
	TMD5Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMD2Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMD2Context));
		intern->len = sizeof(TMD2Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMD2Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMD2Context));
}

SB_PHP_METHOD(TMD2Context, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMD2Context, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMD2Context, get_BufSize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TMD2Context, set_BufSize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

zend_class_entry *TMD2Context_ce_ptr = NULL;

static zend_function_entry TMD2Context_methods[] = {
	PHP_ME(TMD2Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMD2Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMD2Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD2Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD2Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMD2Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMD2Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMD2Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMD2Context", TMD2Context_methods);
	TMD2Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBMD, InitializeMD5)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMD5Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBMD_InitializeMD5((TMD5Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMD5Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMD, FinalizeMD5)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMD5Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest128 roOutResult;
		SBCheckError(SBMD_FinalizeMD5((TMD5Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMD5Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMD, HashMD5)
{
	long u4Size;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaBuffer;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD5(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD5_1(aiBuffer.data, aiBuffer.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMD5Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD5_2((TMD5Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL) or (&TMD5Context, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMD, InitializeMD2)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMD2Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBMD_InitializeMD2((TMD2Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMD2Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMD, FinalizeMD2)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMD2Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest128 roOutResult;
		SBCheckError(SBMD_FinalizeMD2((TMD2Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMD2Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMD, HashMD2)
{
	long l4Size;
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD2(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD2_1(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMD2Context_ce_ptr, &zpBuffer, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMD_HashMD2_2((TMD2Context *)SBGetStructPointer(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL) or (&TMD2Context, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

