#include "sbvcard.h"

zend_class_entry *TElDirInfoAttribute_ce_ptr = NULL;

SB_PHP_METHOD(TElDirInfoAttribute, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfoAttribute_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(474207099, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoAttribute, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfoAttribute_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoAttribute, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfoAttribute_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-511452523, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoAttribute, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfoAttribute_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoAttribute, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoAttribute_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoAttribute_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoAttribute_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoAttribute_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoAttribute_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoAttribute___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDirInfoAttribute_methods[] = {
	PHP_ME(TElDirInfoAttribute, get_Name, arginfo_TElDirInfoAttribute_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoAttribute, set_Name, arginfo_TElDirInfoAttribute_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoAttribute, get_Value, arginfo_TElDirInfoAttribute_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoAttribute, set_Value, arginfo_TElDirInfoAttribute_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoAttribute, __construct, arginfo_TElDirInfoAttribute___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDirInfoAttribute(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDirInfoAttribute_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDirInfoAttribute", TElDirInfoAttribute_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDirInfoAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDirInfoProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElDirInfoProperty, AddAttribute)
{
	zval *oAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAttr, TElDirInfoAttribute_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfoProperty_AddAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAttr TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDirInfoAttribute)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, RemoveAttribute)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDirInfoProperty_RemoveAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, AttributeByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoProperty_AttributeByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfoAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfoProperty_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-818564222, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfoProperty_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfoProperty_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(624027213, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfoProperty_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, get_FullName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfoProperty_get_FullName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1892630518, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, get_Attributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoProperty_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfoAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, get_AttributeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDirInfoProperty_get_AttributeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoProperty, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoProperty_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_AddAttribute, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attr, TElDirInfoAttribute, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_RemoveAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_AttributeByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_get_FullName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_get_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty_get_AttributeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoProperty___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDirInfoProperty_methods[] = {
	PHP_ME(TElDirInfoProperty, AddAttribute, arginfo_TElDirInfoProperty_AddAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, RemoveAttribute, arginfo_TElDirInfoProperty_RemoveAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, AttributeByName, arginfo_TElDirInfoProperty_AttributeByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, get_Name, arginfo_TElDirInfoProperty_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, set_Name, arginfo_TElDirInfoProperty_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, get_Value, arginfo_TElDirInfoProperty_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, set_Value, arginfo_TElDirInfoProperty_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, get_FullName, arginfo_TElDirInfoProperty_get_FullName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, get_Attributes, arginfo_TElDirInfoProperty_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, get_AttributeCount, arginfo_TElDirInfoProperty_get_AttributeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoProperty, __construct, arginfo_TElDirInfoProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDirInfoProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDirInfoProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDirInfoProperty", TElDirInfoProperty_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDirInfoProperty_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDirInfoPropertiesList_ce_ptr = NULL;

SB_PHP_METHOD(TElDirInfoPropertiesList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDirInfoPropertiesList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, Add)
{
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElDirInfoProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfoPropertiesList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDirInfoProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, Insert)
{
	long l4Index;
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oProp, TElDirInfoProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfoPropertiesList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oProp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElDirInfoProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDirInfoPropertiesList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, get_SubProperties)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoPropertiesList_get_SubProperties(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfoProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, get_SubPropertyCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDirInfoPropertiesList_get_SubPropertyCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, get_IsSingle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDirInfoPropertiesList_get_IsSingle(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, get_SingleProperty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoPropertiesList_get_SingleProperty(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfoProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfoPropertiesList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfoPropertiesList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prop, TElDirInfoProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Prop, TElDirInfoProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_get_SubProperties, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_get_SubPropertyCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_get_IsSingle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList_get_SingleProperty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfoPropertiesList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDirInfoPropertiesList_methods[] = {
	PHP_ME(TElDirInfoPropertiesList, Clear, arginfo_TElDirInfoPropertiesList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, Add, arginfo_TElDirInfoPropertiesList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, Insert, arginfo_TElDirInfoPropertiesList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, Remove, arginfo_TElDirInfoPropertiesList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, get_SubProperties, arginfo_TElDirInfoPropertiesList_get_SubProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, get_SubPropertyCount, arginfo_TElDirInfoPropertiesList_get_SubPropertyCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, get_IsSingle, arginfo_TElDirInfoPropertiesList_get_IsSingle, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, get_SingleProperty, arginfo_TElDirInfoPropertiesList_get_SingleProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfoPropertiesList, __construct, arginfo_TElDirInfoPropertiesList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDirInfoPropertiesList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDirInfoPropertiesList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDirInfoPropertiesList", TElDirInfoPropertiesList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDirInfoPropertiesList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDirInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElDirInfo, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, LoadFromFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElDirInfo_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, SaveToFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElDirInfo_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, ToString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfo_ToString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1661555400, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, AddSection)
{
	char *sName;
	int sName_len;
	zval *oSect;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_AddSection(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSect, TElDirInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_AddSection_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSect TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElDirInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, RemoveSection)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDirInfo_RemoveSection(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, AddProperty)
{
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElDirInfoProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_AddProperty(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDirInfoProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, InsertProperty)
{
	long l4Index;
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oProp, TElDirInfoProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_InsertProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oProp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElDirInfoProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, RemoveProperty)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		SBCheckError(TElDirInfo_RemoveProperty(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, RemoveAndAddProperty)
{
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElDirInfoProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_RemoveAndAddProperty(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDirInfoProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, GetPropertyNames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBCheckError(TElDirInfo_GetPropertyNames(SBGetObjectHandle(getThis() TSRMLS_CC), hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TStringList_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, SectionByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_SectionByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, GetPropertyValue)
{
	char *sName;
	int sName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfo_GetPropertyValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1024937086, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, SetPropertyValue)
{
	char *sName;
	char *sValue;
	int sName_len;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfo_SetPropertyValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_Parent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_get_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, set_Parent)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDirInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDirInfo_set_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDirInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1449459406, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDirInfo_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_Include)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_get_Include(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_FullPath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfo_get_FullPath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1505004516, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_FullPathEx)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDirInfo_get_FullPathEx(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1657736317, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_GenerateUID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDirInfo_get_GenerateUID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, set_GenerateUID)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDirInfo_set_GenerateUID(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_Properties)
{
	char *sIndex;
	int sIndex_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIndex, &sIndex_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_get_Properties(SBGetObjectHandle(getThis() TSRMLS_CC), sIndex, (int32_t)sIndex_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfoPropertiesList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_PropertyCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDirInfo_get_PropertyCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_Sections)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_get_Sections(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDirInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, get_SectionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDirInfo_get_SectionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDirInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDirInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_ToString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_AddSection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_Sect, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_RemoveSection, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_AddProperty, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prop, TElDirInfoProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_InsertProperty, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Prop, TElDirInfoProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_RemoveProperty, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_RemoveAndAddProperty, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prop, TElDirInfoProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_GetPropertyNames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_SectionByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_GetPropertyValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_SetPropertyValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_Parent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_set_Parent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDirInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_Include, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_FullPath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_FullPathEx, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_GenerateUID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_set_GenerateUID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_Properties, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_PropertyCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_Sections, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo_get_SectionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDirInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDirInfo_methods[] = {
	PHP_ME(TElDirInfo, LoadFromStream, arginfo_TElDirInfo_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, SaveToStream, arginfo_TElDirInfo_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, LoadFromFile, arginfo_TElDirInfo_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, SaveToFile, arginfo_TElDirInfo_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, ToString, arginfo_TElDirInfo_ToString, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, AddSection, arginfo_TElDirInfo_AddSection, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, RemoveSection, arginfo_TElDirInfo_RemoveSection, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, AddProperty, arginfo_TElDirInfo_AddProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, InsertProperty, arginfo_TElDirInfo_InsertProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, RemoveProperty, arginfo_TElDirInfo_RemoveProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, RemoveAndAddProperty, arginfo_TElDirInfo_RemoveAndAddProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, GetPropertyNames, arginfo_TElDirInfo_GetPropertyNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, SectionByName, arginfo_TElDirInfo_SectionByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, GetPropertyValue, arginfo_TElDirInfo_GetPropertyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, SetPropertyValue, arginfo_TElDirInfo_SetPropertyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_Parent, arginfo_TElDirInfo_get_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, set_Parent, arginfo_TElDirInfo_set_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_Name, arginfo_TElDirInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, set_Name, arginfo_TElDirInfo_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_Include, arginfo_TElDirInfo_get_Include, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_FullPath, arginfo_TElDirInfo_get_FullPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_FullPathEx, arginfo_TElDirInfo_get_FullPathEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_GenerateUID, arginfo_TElDirInfo_get_GenerateUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, set_GenerateUID, arginfo_TElDirInfo_set_GenerateUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_Properties, arginfo_TElDirInfo_get_Properties, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_PropertyCount, arginfo_TElDirInfo_get_PropertyCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_Sections, arginfo_TElDirInfo_get_Sections, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, get_SectionCount, arginfo_TElDirInfo_get_SectionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDirInfo, __construct, arginfo_TElDirInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDirInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDirInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDirInfo", TElDirInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDirInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElVCard_ce_ptr = NULL;

SB_PHP_METHOD(TElVCard, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElVCard_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVCard, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElVCard_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVCard, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVCard_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVCard_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVCard_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVCard___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElVCard_methods[] = {
	PHP_ME(TElVCard, get_Version, arginfo_TElVCard_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElVCard, set_Version, arginfo_TElVCard_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElVCard, __construct, arginfo_TElVCard___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVCard(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVCard_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVCard", TElVCard_methods);
	if (NULL == TElDirInfo_ce_ptr)
		Register_TElDirInfo(TSRMLS_C);
	TElVCard_ce_ptr = zend_register_internal_class_ex(&ce, TElDirInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElVCalendar_ce_ptr = NULL;

SB_PHP_METHOD(TElVCalendar, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVCalendar_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVCalendar___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElVCalendar_methods[] = {
	PHP_ME(TElVCalendar, __construct, arginfo_TElVCalendar___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVCalendar(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVCalendar_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVCalendar", TElVCalendar_methods);
	if (NULL == TElDirInfo_ce_ptr)
		Register_TElDirInfo(TSRMLS_C);
	TElVCalendar_ce_ptr = zend_register_internal_class_ex(&ce, TElDirInfo_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBVCard_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_ERROR_VERSION, SB_VCARDCAL_ERROR_VERSION, SB_VCARDCAL_ERROR_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_ERROR_FORMAT, SB_VCARDCAL_ERROR_FORMAT, SB_VCARDCAL_ERROR_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_ERROR_INTERNAL, SB_VCARDCAL_ERROR_INTERNAL, SB_VCARDCAL_ERROR_INTERNAL);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_ERROR_NON_EXPANDABLE, SB_VCARDCAL_ERROR_NON_EXPANDABLE, SB_VCARDCAL_ERROR_NON_EXPANDABLE);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_ERROR_UNSUPPORTED_VERSION, SB_VCARDCAL_ERROR_UNSUPPORTED_VERSION, SB_VCARDCAL_ERROR_UNSUPPORTED_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_VERSION_UNKNOWN, SB_VCARDCAL_VERSION_UNKNOWN, SB_VCARDCAL_VERSION_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_VERSION_2_1, SB_VCARDCAL_VERSION_2_1, SB_VCARDCAL_VERSION_2_1);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_VERSION_3_0, SB_VCARDCAL_VERSION_3_0, SB_VCARDCAL_VERSION_3_0);
	SB_REGISTER_LONG_CONSTANT(SBVCard, SB_VCARDCAL_VERSION_4_0, SB_VCARDCAL_VERSION_4_0, SB_VCARDCAL_VERSION_4_0);
}
