#include "sbzcommonunit.h"

SB_PHP_METHOD(ct_data_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ct_data_s));
		intern->len = sizeof(ct_data_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ct_data_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ct_data_s));
}

zend_class_entry *ct_data_s_ce_ptr = NULL;

static zend_function_entry ct_data_s_methods[] = {
	PHP_ME(ct_data_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ct_data_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ct_data_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (ct_data_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ct_data_s", ct_data_s_methods);
	ct_data_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(Arrayfff, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(Arrayfff));
		intern->len = sizeof(Arrayfff);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(Arrayfff, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(Arrayfff));
}

zend_class_entry *Arrayfff_ce_ptr = NULL;

static zend_function_entry Arrayfff_methods[] = {
	PHP_ME(Arrayfff, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(Arrayfff, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_Arrayfff(TSRMLS_D)
{
	zend_class_entry ce;
	if (Arrayfff_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "Arrayfff", Arrayfff_methods);
	Arrayfff_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(ArrayWord, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ArrayWord));
		intern->len = sizeof(ArrayWord);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ArrayWord, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ArrayWord));
}

zend_class_entry *ArrayWord_ce_ptr = NULL;

static zend_function_entry ArrayWord_methods[] = {
	PHP_ME(ArrayWord, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ArrayWord, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ArrayWord(TSRMLS_D)
{
	zend_class_entry ce;
	if (ArrayWord_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ArrayWord", ArrayWord_methods);
	ArrayWord_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(ArrayInt, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ArrayInt));
		intern->len = sizeof(ArrayInt);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ArrayInt, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ArrayInt));
}

zend_class_entry *ArrayInt_ce_ptr = NULL;

static zend_function_entry ArrayInt_methods[] = {
	PHP_ME(ArrayInt, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ArrayInt, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ArrayInt(TSRMLS_D)
{
	zend_class_entry ce;
	if (ArrayInt_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ArrayInt", ArrayInt_methods);
	ArrayInt_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(ArrayuInt, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ArrayuInt));
		intern->len = sizeof(ArrayuInt);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ArrayuInt, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ArrayuInt));
}

zend_class_entry *ArrayuInt_ce_ptr = NULL;

static zend_function_entry ArrayuInt_methods[] = {
	PHP_ME(ArrayuInt, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ArrayuInt, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ArrayuInt(TSRMLS_D)
{
	zend_class_entry ce;
	if (ArrayuInt_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ArrayuInt", ArrayuInt_methods);
	ArrayuInt_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(ArrayCt, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ArrayCt));
		intern->len = sizeof(ArrayCt);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ArrayCt, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ArrayCt));
}

zend_class_entry *ArrayCt_ce_ptr = NULL;

static zend_function_entry ArrayCt_methods[] = {
	PHP_ME(ArrayCt, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ArrayCt, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ArrayCt(TSRMLS_D)
{
	zend_class_entry ce;
	if (ArrayCt_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ArrayCt", ArrayCt_methods);
	ArrayCt_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TZStreamRec, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TZStreamRec));
		intern->len = sizeof(TZStreamRec);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TZStreamRec, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TZStreamRec));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TZStreamRec, get_avail_in)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TZStreamRec, set_avail_in)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TZStreamRec, get_total_in)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TZStreamRec, set_total_in)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TZStreamRec, get_avail_out)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TZStreamRec, set_avail_out)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TZStreamRec, get_total_out)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TZStreamRec, set_total_out)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TZStreamRec, get_data_type)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TZStreamRec, set_data_type)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TZStreamRec, get_adler)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TZStreamRec, set_adler)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TZStreamRec, get_reserved)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(TZStreamRec, set_reserved)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

zend_class_entry *TZStreamRec_ce_ptr = NULL;

static zend_function_entry TZStreamRec_methods[] = {
	PHP_ME(TZStreamRec, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TZStreamRec, get_avail_in, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_avail_in, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_total_in, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_total_in, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_avail_out, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_avail_out, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_total_out, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_total_out, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_data_type, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_data_type, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_adler, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_adler, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, get_reserved, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TZStreamRec, set_reserved, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TZStreamRec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TZStreamRec_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TZStreamRec", TZStreamRec_methods);
	TZStreamRec_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(static_tree_desc_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(static_tree_desc_s));
		intern->len = sizeof(static_tree_desc_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(static_tree_desc_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(static_tree_desc_s));
}

SB_PHP_METHOD(static_tree_desc_s, get_extra_base)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(static_tree_desc_s, set_extra_base)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(static_tree_desc_s, get_elems)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(static_tree_desc_s, set_elems)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(static_tree_desc_s, get_max_length)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(static_tree_desc_s, set_max_length)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *static_tree_desc_s_ce_ptr = NULL;

static zend_function_entry static_tree_desc_s_methods[] = {
	PHP_ME(static_tree_desc_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(static_tree_desc_s, get_extra_base, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, set_extra_base, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, get_elems, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, set_elems, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, get_max_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(static_tree_desc_s, set_max_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_static_tree_desc_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (static_tree_desc_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "static_tree_desc_s", static_tree_desc_s_methods);
	static_tree_desc_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(tree_desc_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(tree_desc_s));
		intern->len = sizeof(tree_desc_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(tree_desc_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(tree_desc_s));
}

SB_PHP_METHOD(tree_desc_s, get_max_code)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(tree_desc_s, set_max_code)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *tree_desc_s_ce_ptr = NULL;

static zend_function_entry tree_desc_s_methods[] = {
	PHP_ME(tree_desc_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(tree_desc_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(tree_desc_s, get_max_code, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(tree_desc_s, set_max_code, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_tree_desc_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (tree_desc_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "tree_desc_s", tree_desc_s_methods);
	tree_desc_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(ptr_table_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(ptr_table_s));
		intern->len = sizeof(ptr_table_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(ptr_table_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(ptr_table_s));
}

zend_class_entry *ptr_table_s_ce_ptr = NULL;

static zend_function_entry ptr_table_s_methods[] = {
	PHP_ME(ptr_table_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(ptr_table_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_ptr_table_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (ptr_table_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "ptr_table_s", ptr_table_s_methods);
	ptr_table_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBZCommonUnit, zlibVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBZCommonUnit_zlibVersion(u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-802749151, 0, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCommonUnit, adler32)
{
	long u4adler;
	long u4len;
	SBArrayZValInfo pibuf;
	zval *zpbuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u4adler, &zpbuf, &u4len) == SUCCESS) && ((Z_TYPE_P(zpbuf) == IS_STRING) || (Z_TYPE_P(zpbuf) == IS_ARRAY) || (Z_TYPE_P(zpbuf) == IS_NULL) || ((Z_TYPE_P(zpbuf) == IS_OBJECT) && (Z_OBJCE_P(zpbuf) == TSBPointer_ce_ptr))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpbuf, &pibuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCommonUnit_adler32((uint32_t)u4adler, pibuf.data, (uint32_t)u4len, &u4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&pibuf);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCommonUnit, zlibAllocMem)
{
	long l4Items;
	long l4Size;
	SBArrayZValInfo piAppData;
	zval *zpAppData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zpAppData, &l4Items, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpAppData) == IS_STRING) || (Z_TYPE_P(zpAppData) == IS_ARRAY) || (Z_TYPE_P(zpAppData) == IS_NULL) || ((Z_TYPE_P(zpAppData) == IS_OBJECT) && (Z_OBJCE_P(zpAppData) == TSBPointer_ce_ptr))))
	{
		void * poOutResult = NULL;
		if (!SBGetPointerFromZVal(zpAppData, &piAppData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCommonUnit_zlibAllocMem(piAppData.data, (int32_t)l4Items, (int32_t)l4Size, &poOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piAppData);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCommonUnit, zlibFreeMem)
{
	SBArrayZValInfo piAppData;
	SBArrayZValInfo piBlock;
	zval *zpAppData;
	zval *zpBlock;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpAppData, &zpBlock) == SUCCESS) && ((Z_TYPE_P(zpAppData) == IS_STRING) || (Z_TYPE_P(zpAppData) == IS_ARRAY) || (Z_TYPE_P(zpAppData) == IS_NULL) || ((Z_TYPE_P(zpAppData) == IS_OBJECT) && (Z_OBJCE_P(zpAppData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlock) == IS_STRING) || (Z_TYPE_P(zpBlock) == IS_ARRAY) || (Z_TYPE_P(zpBlock) == IS_NULL) || ((Z_TYPE_P(zpBlock) == IS_OBJECT) && (Z_OBJCE_P(zpBlock) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpAppData, &piAppData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlock, &piBlock TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCommonUnit_zlibFreeMem(piAppData.data, piBlock.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piAppData);
		SBFreePointerZValInfo(&piBlock);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCommonUnit, CCheck)
{
	long l4code;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4code) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZCommonUnit_CCheck((int32_t)l4code, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCommonUnit, ZlibMemCpy)
{
	long l4count;
	SBArrayZValInfo pidest;
	SBArrayZValInfo pisource;
	zval *zpdest;
	zval *zpsource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zpdest, &zpsource, &l4count) == SUCCESS) && ((Z_TYPE_P(zpdest) == IS_STRING) || (Z_TYPE_P(zpdest) == IS_ARRAY) || (Z_TYPE_P(zpdest) == IS_NULL) || ((Z_TYPE_P(zpdest) == IS_OBJECT) && (Z_OBJCE_P(zpdest) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpsource) == IS_STRING) || (Z_TYPE_P(zpsource) == IS_ARRAY) || (Z_TYPE_P(zpsource) == IS_NULL) || ((Z_TYPE_P(zpsource) == IS_OBJECT) && (Z_OBJCE_P(zpsource) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpdest, &pidest TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpsource, &pisource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCommonUnit_ZlibMemCpy(pidest.data, pisource.data, (int32_t)l4count) TSRMLS_CC);
		SBFreePointerZValInfo(&pidest);
		SBFreePointerZValInfo(&pisource);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

void Register_SBZCommonUnit_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, ENOUGH, SB_ENOUGH, SB_ENOUGH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, MAXD, SB_MAXD, SB_MAXD);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, LENGTH_CODES, SB_LENGTH_CODES, SB_LENGTH_CODES);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, LITERALS, SB_LITERALS, SB_LITERALS);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, L_CODES, SB_L_CODES, SB_L_CODES);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, HEAP_SIZE, SB_HEAP_SIZE, SB_HEAP_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, D_CODES, SB_D_CODES, SB_D_CODES);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, BL_CODES, SB_BL_CODES, SB_BL_CODES);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, MAX_BITS, SB_MAX_BITS, SB_MAX_BITS);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, ZLIB_VERNUM, SB_ZLIB_VERNUM, SB_ZLIB_VERNUM);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_NO_FLUSH, SB_Z_NO_FLUSH, SB_Z_NO_FLUSH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_PARTIAL_FLUSH, SB_Z_PARTIAL_FLUSH, SB_Z_PARTIAL_FLUSH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_SYNC_FLUSH, SB_Z_SYNC_FLUSH, SB_Z_SYNC_FLUSH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_FULL_FLUSH, SB_Z_FULL_FLUSH, SB_Z_FULL_FLUSH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_FINISH, SB_Z_FINISH, SB_Z_FINISH);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_BLOCK, SB_Z_BLOCK, SB_Z_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_OK, SB_Z_OK, SB_Z_OK);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_STREAM_END, SB_Z_STREAM_END, SB_Z_STREAM_END);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_NEED_DICT, SB_Z_NEED_DICT, SB_Z_NEED_DICT);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_STREAM_ERROR, SB_Z_STREAM_ERROR, SB_Z_STREAM_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_DATA_ERROR, SB_Z_DATA_ERROR, SB_Z_DATA_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_MEM_ERROR, SB_Z_MEM_ERROR, SB_Z_MEM_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_BUF_ERROR, SB_Z_BUF_ERROR, SB_Z_BUF_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_VERSION_ERROR, SB_Z_VERSION_ERROR, SB_Z_VERSION_ERROR);
	SB_REGISTER_NULL_CONSTANT(SBZCommonUnit, Z_NULL, SB_Z_NULL);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, MAX_PTR, SB_MAX_PTR, SB_MAX_PTR);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, MAX_WBITS, SB_MAX_WBITS, SB_MAX_WBITS);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_RLE, SB_Z_RLE, SB_Z_RLE);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_FIXED, SB_Z_FIXED, SB_Z_FIXED);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, Z_DEFLATED, SB_Z_DEFLATED, SB_Z_DEFLATED);
	SB_REGISTER_LONG_CONSTANT(SBZCommonUnit, PRESET_DICT, SB_PRESET_DICT, SB_PRESET_DICT);
}

void Register_SBZCommonUnit_Aliases(TSRMLS_D)
{
	if (NULL == ct_data_s_ce_ptr)
		Register_ct_data_s(TSRMLS_C);
	zend_register_class_alias("ct_data", ct_data_s_ce_ptr);
	if (NULL == static_tree_desc_s_ce_ptr)
		Register_static_tree_desc_s(TSRMLS_C);
	zend_register_class_alias("static_tree_desc", static_tree_desc_s_ce_ptr);
	if (NULL == tree_desc_s_ce_ptr)
		Register_tree_desc_s(TSRMLS_C);
	zend_register_class_alias("tree_desc", tree_desc_s_ce_ptr);
	if (NULL == ptr_table_s_ce_ptr)
		Register_ptr_table_s(TSRMLS_C);
	zend_register_class_alias("ptr_table", ptr_table_s_ce_ptr);
}

